package com.example.ellegadodepintia.exploradoresDePintia.model.efecto

import android.graphics.drawable.AnimationDrawable
import android.widget.ImageView
import com.example.ellegadodepintia.R
import com.example.ellegadodepintia.exploradoresDePintia.model.Atributo
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState
import com.example.ellegadodepintia.exploradoresDePintia.model.objeto.Objeto
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState.context
import com.example.ellegadodepintia.soundManager.SoundManager

class EfectoRiesgo(private val objetoRecompensa : Objeto, private val dmgRiesgo: Int, private val mensajeRecomensa : String, private val mensajeRiesgo : String,
                   probabilidadExito: Int
) : Efecto(probabilidadExito) {
    private lateinit var soundManager: SoundManager
    override fun ejecutar(): String {
        val resultado = (1..100).random()
        soundManager = SoundManager(context!!)
        soundManager.playSound(R.raw.sound_cofre,100)
        val imageView: ImageView = context!!.findViewById(R.id.imagenEvento)
        val animationDrawable = imageView.drawable as? AnimationDrawable

        val animationDuration = animationDrawable?.let { anim ->
            var totalDuration = 0
            for (i in 0 until anim.numberOfFrames) {
                totalDuration += anim.getDuration(i)
            }
            totalDuration
        } ?: 0

        animationDrawable?.start()

        imageView.postDelayed({
            animationDrawable?.let { anim ->
                anim.stop()
                anim.selectDrawable(anim.numberOfFrames - 1)
            }
        }, animationDuration.toLong() - 150)

        if (resultado <= probabilidadExito) {
            GameState.jugador.conseguirObjeto(objetoRecompensa)
            GameState.eventoActual.actualizarFinalizado(true)
            return mensajeRecomensa
        } else {
            GameState.jugador.actualizarAtributo(Atributo.Vida, -dmgRiesgo)
            GameState.eventoActual.actualizarFinalizado(true)
            return mensajeRiesgo
        }

    }
}